require 'redis'

class Reddish
  def initialize port=6379
    @redis = Redis.new port: port
  end

  def get key
    @redis.get key.to_s
  end

  def set key, value
    @redis.set key.to_s, value
  end

  def [] key
    @redis.get key.to_s
  end

  def []= key, value
    @redis.set key.to_s, value
  end

  def method_missing m, *args, &block
    m = m.to_s

    if @redis.public_methods.include? m
      @redis.send m, *args, &block
    elsif m.end_with? '='
      @redis.set m.chomp('='), *args.first
    else
      @redis.get m
    end
  end
end
